function [y,sigmab2]=adgnoise(y,snr)
%
% This program is a supplementary material to the paper:
%
% From Bernoulli-Gaussian deconvolution to sparse signal restoration, 
% by Charles Soussen, Jerome Idier, David Brie, and Junbo Duan. 
% IEEE Trans. Signal Process., vol. 59, no. 10, pp. 4572-4584, Oct. 2011.
%
% Copyright (c) 2011 IEEE
% Contact information: Charles.Soussen@univ-lorraine.fr
%------------------------------------------------------------------------
% adgnoise.m       Add Gaussian white noise to observation
%         
% [yb,sigmab2]  = adgnoise(y,SNR)
% This program adds a Gaussian white noise to a data signal y
% with a signal-to-noise ratio equal to SNR 
% 
%------------------------------------------------------------------------

sigmab2 = 10^(-snr/10)*mean(y(:).*y(:));
sigmab = sqrt(sigmab2);
y = y + randn(size(y))*sigmab;

